package fr.enst.cours.mvc2010;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.border.Border;

public class DemoRichUnitV4 {
    public static void main(String[] args) throws IOException {
	BufferedImage img = ImageIO.read(new File("cavalier-ranged-2.png"));
	GraphicalUnit unit = new GraphicalUnit(img);
	unit.moveTo(100, 100);
	RichUnitView vue = new RichUnitView(unit);
	vue.setPreferredSize(new Dimension(400, 400));
	ScaledRichUnitView vue2 = new ScaledRichUnitView(unit);
	vue2.setPreferredSize(new Dimension(80, 80));
	SimpleUnitView vue3 = new SimpleUnitView(unit);
	vue3.setPreferredSize(new Dimension(80, 80));
	UnitMouseControllerAnimated controller = new UnitMouseControllerAnimated(unit);
	vue.addMouseListener(controller);
	RequestFocus rf = new RequestFocus(vue);
	// décoration
	Border blackBorder = BorderFactory.createLineBorder(Color.BLACK);
	vue.setBorder(blackBorder);
	vue2.setBorder(blackBorder);
	vue3.setBorder(blackBorder);
	// la fenêtre principale
	JFrame cadre = new JFrame("Unité");
	cadre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	cadre.getContentPane().setLayout(new GridBagLayout());
	GridBagConstraints c = new GridBagConstraints();
	// global
	c.insets = new Insets(10, 10, 10, 10);
	// spécifique
	c.gridx = 0;
	c.gridy = 0;
	c.gridheight=2;
	cadre.getContentPane().add(vue, c);
	c.gridx = 1;
	c.gridy = 0;
	c.gridheight=1;
	c.anchor = GridBagConstraints.CENTER;
	cadre.getContentPane().add(vue2, c);
	c.gridx = 1;
	c.gridy = 1;
	c.anchor = GridBagConstraints.CENTER;
	cadre.getContentPane().add(vue3, c);
	cadre.pack();
	// cadre.setSize(600, 450);
	// affichage
	cadre.setVisible(true);
    }
}
