package fr.enst.cours.mvc2010;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

public class Mouvement implements ActionListener {
    private Unit unit;
    private int startX;
    private int startY;
    private int endX;
    private int endY;

    private int end;
    private int current;
    private Timer timer;

    private static final int speed = 150;
    private static final int frameRate = 24;

    public void moveTo(Unit unit, int endX, int endY) {
	if (unit.isMoving()) {
	    System.err.println("Unit is already moving");
	} else {
	    startX = unit.getX();
	    startY = unit.getY();
	    this.endX = endX;
	    this.endY = endY;
	    this.unit = unit;
	    unit.setMoving(true);
	    current = 0;
	    end = 1 + frameRate* Math.max(Math.abs(startX - endX), Math.abs(startY - endY)) / speed;
	    timer = new Timer(0, this);
	    timer.setDelay(1000 / frameRate);
	    timer.start();
	}
    }

    @Override
    public void actionPerformed(ActionEvent e) {
	current++;
	if (current == end) {
	    timer.stop();
	    unit.moveTo(endX, endY);
	    unit.setMoving(false);
	} else {
	    double deltaX = endX - startX;
	    double deltaY = endY - startY;
	    int posX = (int) Math.round(startX + current * deltaX / end);
	    int posY = (int) Math.round(startY + current * deltaY / end);
	    unit.moveTo(posX, posY);
	}
    }
}
