package fr.enst.cours.mvc2010;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;

public class ScaledRichUnitView extends JPanel implements Observer {
    private GraphicalUnit myUnit;

    public ScaledRichUnitView(GraphicalUnit myUnit) {
	this.myUnit = myUnit;
	myUnit.addObserver(this);
    }

    @Override
    public void update(Observable o, Object arg) {
	repaint();
    }

    @Override
    protected void paintComponent(Graphics g) {
	super.paintComponent(g);
	Graphics2D g2 = (Graphics2D)g;
	AffineTransform ct = g2.getTransform();
	g2.scale(0.2, 0.2);
	myUnit.paint(g2);
	g2.setTransform(ct);
    }
}
