package fr.enst.cours.mvc2010;

import java.awt.Graphics;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;

public class SimpleUnitView extends JPanel implements Observer {
    private GraphicalUnit myUnit;
    private int scale=5;
    public SimpleUnitView(GraphicalUnit myUnit) {
	this.myUnit = myUnit;
	myUnit.addObserver(this);
    }
    
    @Override
    public void update(Observable o, Object arg) {
	repaint();
    }

    @Override
    protected void paintComponent(Graphics g) {
	super.paintComponent(g);
	int h=Math.max(myUnit.getPicture().getHeight()/scale,2)/2;
	int w=Math.max(myUnit.getPicture().getWidth()/scale,2)/2;
	int x=myUnit.getX()/scale;
	int y=myUnit.getY()/scale;
	g.fillRect(x-w/2, y-h/2, w, h);
    }

    
}
