package fr.enst.cours.mvc2010;

import java.awt.Color;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JLabel;

public class VueNoteTexteObserver extends JLabel implements Observer {
    private NoteObservable note;

    public VueNoteTexteObserver(NoteObservable note) {
	this.note = note;
	note.addObserver(this);
	setHorizontalTextPosition(CENTER);
	setOpaque(true);
	update();
    }
    public void update() {
	if(note.isInitialized()) {
	    setForeground(Color.BLACK);
	    setText(String.valueOf(note.getValue()));
	} else {
	    setForeground(Color.LIGHT_GRAY);
	    setText("aucune");
	}
    }
    @Override
    public void update(Observable source, Object value) {
	update();
    }
}
